from math import gcd

def lcm(a, b):
    return a * b // gcd(a, b)

def find_buttons(n, k, rooms):
    buttons = []
    lcm_value = 1
    for i in range(k):
        buttons.append(rooms[i])
        lcm_value = lcm(lcm_value, rooms[i])
        if lcm_value > n:
            return -1
    if n % lcm_value != 0:
        return -1
    result = [lcm_value]
    for i in range(1, n+1):
        if all(i % button == 0 for button in buttons):
            result.append(i)
    return result

n, k = map(int, input().split())
rooms = list(map(int, input().split()))

result = find_buttons(n, k, rooms)
if result == -1:
    print(-1)
else:
    print(len(result))
    print(*result)